define(['jquery', 'bootstrap', 'backend', 'table', 'form'], function ($, undefined, Backend, Table, Form) {

    var Controller = {
        index: function () {
            // 初始化表格参数配置
            Table.api.init({
                extend: {
                    index_url: 'student/practice/index' + location.search,
                    table: 'teacher_collection',
                }
            });

            var table = $("#table");

            // 初始化表格
            table.bootstrapTable({
                url: $.fn.bootstrapTable.defaults.extend.index_url,
                pk: 'exam_collection_id',
                sortName: 'exam_collection_id',
                fixedColumns: true,
                fixedRightNumber: 1,
                searchFormVisible:true,
                columns: [
                    [
                        {checkbox: true},
                        {field: 'exam_collection_id', title: __('编号')},
                        {field: 'exam_collection_name', title: __('Exam_collection_name'), operate: 'LIKE', table: table, class: 'autocontent', formatter: Table.api.formatter.content},
                        {field: 'sim_type', title: __('Sim_type'),searchList:{"0001":"FZD04B型侦毒器","0002":"FZB006型毒剂报警器","0003":"防化兵用毒剂报警器"},formatter: Table.api.formatter.simtype},
                        {field: 'question_setting_method', title: __('Question_setting_method'),searchList:{"1":"系统随机","2":"教师自选","3":"任务自选"},formatter: Table.api.formatter.simmethod},
                        // {field: 'exam_collection_type', title: __('Exam_collection_type'),operate: false,formatter: function (value, row, index) {
                        //         return '考试';
                        //     }
                        // },
                        // {
                        //     field: 'exam_collection_state',searchList:{"2":"打开","3":"关闭"},
                        //     title: __('Exam_collection_state'),
                        //     align: 'center',
                        //     table: table,disable:true,
                        //     formatter: Table.api.formatter.collectonstate
                        // },

                        {field: 'limit_duration', title: __('Limit_duration')},
                        {field: 'start_time', title: __('Start_time'), operate:'RANGE', addclass:'datetimerange', autocomplete:false},
                        {field: 'end_time', title: __('End_time'), operate:'RANGE', addclass:'datetimerange', autocomplete:false},
                        // {field: 'create_user_id', title: __('Create_user_id')},
                        {field: 'create_by', title: __('Create_by'), operate: 'LIKE'},
                        // {field: 'createtime', title: __('Create_time'), operate:'RANGE', addclass:'datetimerange', autocomplete:false},
                        // {field: 'update_by', title: __('Update_by'), operate: 'LIKE'},
                        // {field: 'update_time', title: __('Update_time'), operate:'RANGE', addclass:'datetimerange', autocomplete:false},
                        // {field: 'remark', title: __('Remark'), operate: 'LIKE', table: table, class: 'autocontent', formatter: Table.api.formatter.content},
                        // {field: 'operate', title: __('Operate'), table: table, events: Table.api.events.operate, formatter: Table.api.formatter.operate}
                        {field: 'operate', title: __('Operate'), table: table,
                            events: Table.api.events.operate,
                            // formatter: Table.api.formatter.operate,
                            formatter: Table.api.formatter.buttons,
                            buttons: [
                                {
                                    name: 'dispatch',
                                    text: '进入',
                                    icon: 'fa fa-hand-pointer-o',
                                    title: '进入',
                                    // visible: function (row){
                                    //     if(row.is_user_examed==0){
                                    //         return true;
                                    //     }
                                    //     return  false;
                                    // },
                                    classname: 'btn btn-info btn-xs btn-magic btn-addtabs',
                                    extend: 'data-area=\'["85%","85%"]\'',
                                    url: 'student/practice/into',
                                }
                            ],
                        }
                    ]

                ]
            });

            // 为表格绑定事件
            Table.api.bindevent(table);
        },
        add: function () {
            Controller.api.bindevent();
        },
        into: function () {
            // Controller.api.bindevent();
            // Form.api.bindevent($("form[role=form]"), function(data, ret) {
            //     if(ret.code==1){
            //         Backend.api.addtabs( ret.url,'正在练习');
            //     }
            // });
            $(document).on('click', '.btn-startexam', function () {
                if(Config.is_fault){
                    // $.ajax({
                    //     url: Config.url_type+"/sim/real-exam/student/exam/start/"+Config.exam_id,
                    //     type: 'get',
                    //     success: function (data) {
                    //         console.log(data);
                    //         if(data.code==200){
                    //             window.location.href = '/ZQOtIMLKud.php/student/collection/examing/ids/'+Config.exam_id;
                    //         }else{
                    //             Layer.alert(data.msg);
                    //             return;
                    //         }
                    //     }
                    // });
                }else{
                    window.location.href = '/ZQOtIMLKud.php/student/practice/examing/ids/'+Config.exam_id;
                }
            });
        },
        examing: function () {
            $(document).ready(function() {
                var countdownTime = Config.timer; // 倒计时时间，单位为秒
                var display = $('#timer');
                var fenzhong = 0;
                var timer = setInterval(function() {
                    var minutes = parseInt(countdownTime / 60, 10);
                    var seconds = parseInt(countdownTime % 60, 10);

                    minutes = minutes < 10 ? "0" + minutes : minutes;
                    seconds = seconds < 10 ? "0" + seconds : seconds;

                    display.text(minutes + "分" + seconds+'秒');

                    // console.log(minutes.replace("0-",''));
                    // console.log(parseInt(minutes.replace("0-",'')));
                    if (--countdownTime < 0) {
                        // clearInterval(timer);
                        $(".djs").html('已到练习结束时间，10分钟内系统自动交卷。')
                        // display.text("时间到!");
                    }
                    if(minutes<1){
                        fenzhong = parseInt(minutes.replace("0-",''));
                        console.log(fenzhong);
                        if(fenzhong==7){
                            $('#update-form').submit();
                            clearInterval(timer);
                        }
                    }

                }, 1000);

                //五秒刷新,同步更换件列表数据
                if(Config.isloading==1 && countdownTime>0){
                    setInterval(function() {
                        window.location.reload();
                    }, 30000);
                }

            });

            $(document).on('click', '.btn-replace', function () {
                console.log($(".other_replace").val());
                $.ajax({
                    url: "student/collection/replace/ids/"+Config.ids,
                    type: 'post',
                    data: {
                        other_replace: $(".other_replace").val(),
                        other_report: $(".other_report").val(),
                    },
                    success: function (data) {
                        if(data.code==1){
                            window.location.reload();
                        }
                        if(data.code==0){
                            Layer.alert(data.msg);
                        }
                    }
                });
            });

            $(document).on("fa.event.appendfieldlist", "#second-fieldlist .btn-append", function (e, obj) {
                //绑定动态下拉组件
                Form.events.selectpage(obj);

            });

            Form.api.bindevent($("form[role=form]"), function(data, ret) {
                if(ret.code==1){
                    Backend.api.addtabs( ret.url,'得分分析');
                }
            });
        },
        analysis: function () {
            Form.api.bindevent($("form[role=form]"), function(data, ret) {
                if(ret.code==1){
                    Backend.api.addtabs( ret.url);
                    parent.window.reload();
                }
            });
        },
        edit: function () {
            Controller.api.bindevent();
        },
        api: {
            bindevent: function () {
                Form.api.bindevent($("form[role=form]"));
            }
        }
    };
    return Controller;
});
